RDMA_REG_READ(3)

NAME
rdma_reg_read - register data buffer(s) for remote RDMA read access.

SYNOPSIS
#include <rdma/rdma_verbs.h>

struct ibv_mr * rdma_reg_read (struct rdma_cm_id *id, void *addr, size_t length);

ARGUMENTS

id  A reference to a communication identifier where the message buffer(s) will be used.

addr
    The address of the memory buffer(s) to register.

length
    The total length of the memory to register.

DESCRIPTION
Registers a memory buffer that will be accessed by a remote RDMA read operation. Memory buffers registered using rdma_reg_read may be targeted in an RDMA read request, allowing the buffer to be specified on the remote side of an RDMA connection as the remote_addr of rdma_post_read, or similar call.

RETURN VALUE
Returns a reference to the registered memory region on success, or NULL on error. If an error occurs, errno will be set to indicate the failure reason.

NOTES
rdma_reg_read is used to register a data buffer that will be the target of an RDMA read operation on a queue pair associated with an rdma_cm_id. The memory buffer is registered with the proteection domain associated with the idenfier. The start of the data buffer is specified through the addr parameter, and the total size of the buffer is given by length.

All data buffers should be registered before being posted as a work request. Users must deregister all registered memory by calling rdma_dereg_mr.

SEE ALSO
rdma_cm(7), rdma_create_id(3), rdma_create_ep(3), rdma_reg_msgs(3), rdma_reg_write(3), ibv_reg_mr(3), ibv_dereg_mr(3), rdma_post_read(3)